
import Docxtemplater from 'docxtemplater';
import  ExcelJS from 'exceljs'
import FileSaver, { saveAs } from 'file-saver';
import JSZipUtils from 'jszip-utils'
import Pizzip from 'pizzip';

function getExcel(val,intro,tit,ty){
// return console.log(val,intro,tit,ty);
    // 下载Excel文件
    JSZipUtils.getBinaryContent('file/学校创客专项资金使用申请表 (1).xlsx', (err, data) => {
        if (err) {
            console.error(err);
            return;
        }
    
        // 创建一个新的Excel工作簿
        const workbook = new ExcelJS.Workbook();
    
        // 从Excel文件的Buffer中加载工作簿
        workbook.xlsx.load(data)
        .then(() => {
            //获取第一个工作表
            let worksheet = workbook.getWorksheet(1);

            // 添加一个工作表
            // const sheet = workbook.addWorksheet('My Sheet');

            // budget   预算
            // havePaid   已支付
            // thisApply   这次申请
            // remark     备注

            worksheet.getCell("G2").value=`项目类型： 个人创客 ${ty==1?'√':'□'}     创客活动 ${ty==0?'√':'□'}   `
            //项目名称
            worksheet.getCell('G3').value=`项目名称:${tit}`;



            worksheet.getCell('C7').value=val[0].budget;
            worksheet.getCell('D7').value=val[0].havePaid;
            worksheet.getCell('E7').value=val[0].thisApply;
            worksheet.getCell('G7').value=val[0].remark;

            worksheet.getCell('C8').value=val[1].budget;
            worksheet.getCell('D8').value=val[1].havePaid;
            worksheet.getCell('E8').value=val[1].thisApply;
            worksheet.getCell('G8').value=val[1].remark;

            worksheet.getCell('C9').value=val[2].budget;
            worksheet.getCell('D9').value=val[2].havePaid;
            worksheet.getCell('E9').value=val[2].thisApply;
            worksheet.getCell('G9').value=val[2].remark;

            worksheet.getCell('C10').value=val[3].budget;
            worksheet.getCell('D10').value=val[3].havePaid;
            worksheet.getCell('E10').value=val[3].thisApply;
            worksheet.getCell('G10').value=val[3].remark;

            worksheet.getCell('C13').value=val[4].budget;
            worksheet.getCell('D13').value=val[4].havePaid;
            worksheet.getCell('E13').value=val[4].thisApply;
            worksheet.getCell('G13').value=val[4].remark;

            worksheet.getCell('C14').value=val[5].budget;
            worksheet.getCell('D14').value=val[5].havePaid;
            worksheet.getCell('E14').value=val[5].thisApply;
            worksheet.getCell('G14').value=val[5].remark;

            worksheet.getCell('C15').value=val[6].budget;
            worksheet.getCell('D15').value=val[6].havePaid;
            worksheet.getCell('E15').value=val[6].thisApply;
            worksheet.getCell('G15').value=val[6].remark;

            worksheet.getCell('C16').value=val[7].budget;
            worksheet.getCell('D16').value=val[7].havePaid;
            worksheet.getCell('E16').value=val[7].thisApply;
            worksheet.getCell('G16').value=val[7].remark;

            // worksheet.getCell('B18').value=val.intro;
            worksheet.getCell("B18").value=intro;
            worksheet.getCell('B18').alignment = { vertical: 'top', horizontal: 'left' };


    //自动计算的单元格
    //直接经费
        //小型仪器设备费余额
        worksheet.getCell("F7").value = {formula:"C7-D7-E7",result:worksheet.getCell("C7")-worksheet.getCell("D7")-worksheet.getCell("E7")}
        //材料费余额
        worksheet.getCell("F8").value = {formula:"C8-D8-E8",result:worksheet.getCell("C8")-worksheet.getCell("D8")-worksheet.getCell("E8")}
        //测试化验加工费余额
        worksheet.getCell("F9").value = {formula:"C9-D9-E9",result:worksheet.getCell("C9")-worksheet.getCell("D9")-worksheet.getCell("E9")}
        //项目协作费余额
        worksheet.getCell("F10").value = {formula:"C10-D10-E10",result:worksheet.getCell("C10")-worksheet.getCell("D10")-worksheet.getCell("E10")}
        //其他支出余额
        worksheet.getCell("F11").value = {formula:"C11-D11-E11",result:worksheet.getCell("C11")-worksheet.getCell("D11")-worksheet.getCell("E11")}
        //总预算
        worksheet.getCell("C6").value = {formula:"SUM(C7:C11)",result:worksheet.getCell("C7")*1+worksheet.getCell("C8")*1+worksheet.getCell("C9")*1+worksheet.getCell("C10")*1+worksheet.getCell("C11")*1}
        //已支付
        worksheet.getCell("D6").value = {formula:"SUM(D7:D11)",result:worksheet.getCell("D7")*1+worksheet.getCell("D8")*1+worksheet.getCell("D9")*1+worksheet.getCell("D10")*1+worksheet.getCell("D11")*1}
        //本次申请
        worksheet.getCell("E6").value = {formula:"SUM(E7:E11)",result:worksheet.getCell("E7")*1+worksheet.getCell("E8")*1+worksheet.getCell("E9")*1+worksheet.getCell("E10")*1+worksheet.getCell("E11")*1}
        //余额
        worksheet.getCell("F6").value = {formula:"C6-D6-E6",result:worksheet.getCell("C6")*1-worksheet.getCell("D6")*1-worksheet.getCell("E6")*1}
    //间接经费
        //项目成果鉴定费余额
        worksheet.getCell("F13").value = {formula:"C13-D13-E13",result:worksheet.getCell("C13")-worksheet.getCell("D13")-worksheet.getCell("E13")}
        //参展参赛费余额
        worksheet.getCell("F14").value = {formula:"C14-D14-E14",result:worksheet.getCell("C14")-worksheet.getCell("D14")-worksheet.getCell("E14")}
        //创客交流活动费余额
        worksheet.getCell("F15").value = {formula:"C15-D15-E15",result:worksheet.getCell("C15")-worksheet.getCell("D15")-worksheet.getCell("E15")}
        //知识产权事务费余额
        worksheet.getCell("F16").value = {formula:"C16-D16-E16",result:worksheet.getCell("C16")-worksheet.getCell("D16")-worksheet.getCell("E16")}
        //其他支出余额
        worksheet.getCell("F17").value = {formula:"C17-D17-E17",result:worksheet.getCell("C17")-worksheet.getCell("D17")-worksheet.getCell("E17")}
        //总预算
        worksheet.getCell("C12").value = {formula:"SUM(C13:C17)",result:worksheet.getCell("C13")*1+worksheet.getCell("C14")*1+worksheet.getCell("C15")*1+worksheet.getCell("C16")*1+worksheet.getCell("C17")*1}
        //已支付
        worksheet.getCell("D12").value = {formula:"SUM(D13:D17)",result:worksheet.getCell("D13")*1+worksheet.getCell("D14")*1+worksheet.getCell("D15")*1+worksheet.getCell("D16")*1+worksheet.getCell("D17")*1}
        //本次申请
        worksheet.getCell("E12").value = {formula:"SUM(E13:E17)",result:worksheet.getCell("E13")*1+worksheet.getCell("E14")*1+worksheet.getCell("E15")*1+worksheet.getCell("E16")*1+worksheet.getCell("E17")*1}
        //余额
        worksheet.getCell("F12").value = {formula:"C12-D12-E12",result:worksheet.getCell("C12")*1-worksheet.getCell("D12")*1-worksheet.getCell("E12")*1}
    //经费支出
        //总预算
        worksheet.getCell("C5").value = {formula:"SUM(C6+C12)",result:worksheet.getCell("C6")*1+worksheet.getCell("C12")*1}
        //总支出
        worksheet.getCell("D5").value=  {formula:"SUM(D6+D12)",result:worksheet.getCell("D6")*1+worksheet.getCell("D12")*1}
        //总申请
        worksheet.getCell("E5").value = {formula:"SUM(E6+E12)",result:worksheet.getCell("E6")*1+worksheet.getCell("E12")*1}
        //总余额
        worksheet.getCell("F5").value = {formula:"SUM(F6+F12)",result:worksheet.getCell("F6")*1+worksheet.getCell("F12")*1}











            // 将工作簿保存为Excel文件
            return workbook.xlsx.writeBuffer();
        })
        .then(buffer => {
            // 将Excel文件保存到本地计算机
            const excelBlob = new Blob([buffer], { type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' });
            FileSaver.saveAs(excelBlob, '学校创客专项资金使用申请表.xlsx');
        });
    });
} 

function getExcel2(val,intro,tit,ty){
    // return console.log(val,intro);
        // 下载Excel文件
        JSZipUtils.getBinaryContent('file/附件 5 ：学校创客专项资金使用申请表.xlsx', (err, data) => {
            if (err) {
                console.error(err);
                return;
            }
        
            // 创建一个新的Excel工作簿
            const workbook = new ExcelJS.Workbook();
        
            // 从Excel文件的Buffer中加载工作簿
            workbook.xlsx.load(data)
            .then(() => {
                //获取第一个工作表
                let worksheet = workbook.getWorksheet(1);
    
                // 添加一个工作表
                // const sheet = workbook.addWorksheet('My Sheet');
    
                // budget   预算
                // havePaid   已支付
                // thisApply   这次申请
                // remark     备注
                
                worksheet.getCell("G2").value=`项目类型： 个人创客 ${ty==1?'√':'□'}     创客活动 ${ty==0?'√':'□'}   `
                //项目名称
                worksheet.getCell('G3').value=`项目名称:${tit}`;


                worksheet.getCell('C7').value=val[0].budget;
                worksheet.getCell('D7').value=val[0].havePaid;
                worksheet.getCell('E7').value=val[0].thisApply;
                worksheet.getCell('F7').value=val[0].actualuse;
                worksheet.getCell('H7').value=val[0].remark;
    
                worksheet.getCell('C8').value=val[1].budget;
                worksheet.getCell('D8').value=val[1].havePaid;
                worksheet.getCell('E8').value=val[1].thisApply;
                worksheet.getCell('F8').value=val[1].actualuse;
                worksheet.getCell('H8').value=val[1].remark;
    
                worksheet.getCell('C9').value=val[2].budget;
                worksheet.getCell('D9').value=val[2].havePaid;
                worksheet.getCell('E9').value=val[2].thisApply;
                worksheet.getCell('F9').value=val[2].actualuse;
                worksheet.getCell('H9').value=val[2].remark;
    
                worksheet.getCell('C10').value=val[3].budget;
                worksheet.getCell('D10').value=val[3].havePaid;
                worksheet.getCell('E10').value=val[3].thisApply;
                worksheet.getCell('F10').value=val[3].actualuse;
                worksheet.getCell('H10').value=val[3].remark;
    
                worksheet.getCell('C13').value=val[4].budget;
                worksheet.getCell('D13').value=val[4].havePaid;
                worksheet.getCell('E13').value=val[4].thisApply;
                worksheet.getCell('F13').value=val[4].actualuse;
                worksheet.getCell('H13').value=val[4].remark;
    
                worksheet.getCell('C14').value=val[5].budget;
                worksheet.getCell('D14').value=val[5].havePaid;
                worksheet.getCell('E14').value=val[5].thisApply;
                worksheet.getCell('F14').value=val[5].actualuse;
                worksheet.getCell('H14').value=val[5].remark;
    
                worksheet.getCell('C15').value=val[6].budget;
                worksheet.getCell('D15').value=val[6].havePaid;
                worksheet.getCell('E15').value=val[6].thisApply;
                worksheet.getCell('F15').value=val[6].actualuse;
                worksheet.getCell('H15').value=val[6].remark;
    
                worksheet.getCell('C16').value=val[7].budget;
                worksheet.getCell('D16').value=val[7].havePaid;
                worksheet.getCell('E16').value=val[7].thisApply;
                worksheet.getCell('F16').value=val[7].actualuse;
                worksheet.getCell('H16').value=val[7].remark;
    
                // worksheet.getCell('B18').value=val.intro;
                worksheet.getCell("B18").value=intro;
                worksheet.getCell('B18').alignment = { vertical: 'top', horizontal: 'left' };
    
    
        //自动计算的单元格
        //直接经费
            //小型仪器设备费余额
            worksheet.getCell("G7").value = {formula:"C7-D7-F7",result:worksheet.getCell("C7")-worksheet.getCell("D7")-worksheet.getCell("F7")}
            //材料费余额
            worksheet.getCell("G8").value = {formula:"C8-D8-F8",result:worksheet.getCell("C8")-worksheet.getCell("D8")-worksheet.getCell("F8")}
            //测试化验加工费余额
            worksheet.getCell("G9").value = {formula:"C9-D9-F9",result:worksheet.getCell("C9")-worksheet.getCell("D9")-worksheet.getCell("F9")}
            //项目协作费余额
            worksheet.getCell("G10").value = {formula:"C10-D10-F10",result:worksheet.getCell("C10")-worksheet.getCell("D10")-worksheet.getCell("F10")}
            //其他支出余额
            worksheet.getCell("G11").value = {formula:"C11-D11-F11",result:worksheet.getCell("C11")-worksheet.getCell("D11")-worksheet.getCell("F11")}
            //总预算
            worksheet.getCell("C6").value = {formula:"SUM(C7:C11)",result:worksheet.getCell("C7")*1+worksheet.getCell("C8")*1+worksheet.getCell("C9")*1+worksheet.getCell("C10")*1+worksheet.getCell("C11")*1}
            //已支付
            worksheet.getCell("D6").value = {formula:"SUM(D7:D11)",result:worksheet.getCell("D7")*1+worksheet.getCell("D8")*1+worksheet.getCell("D9")*1+worksheet.getCell("D10")*1+worksheet.getCell("D11")*1}
            //本次申请
            worksheet.getCell("E6").value = {formula:"SUM(E7:E11)",result:worksheet.getCell("E7")*1+worksheet.getCell("E8")*1+worksheet.getCell("E9")*1+worksheet.getCell("E10")*1+worksheet.getCell("E11")*1}
            //实际使用
            worksheet.getCell("F6").value = {formula:"SUM(F7:F11)",result:worksheet.getCell("F7")*1+worksheet.getCell("F8")*1+worksheet.getCell("F9")*1+worksheet.getCell("F10")*1+worksheet.getCell("F11")*1}
            //余额
            worksheet.getCell("G6").value = {formula:"C6-D6-F6",result:worksheet.getCell("C6")*1-worksheet.getCell("D6")*1-worksheet.getCell("F6")*1}
        //间接经费
            //项目成果鉴定费余额
            worksheet.getCell("G13").value = {formula:"C13-D13-F13",result:worksheet.getCell("C13")-worksheet.getCell("D13")-worksheet.getCell("F13")}
            //参展参赛费余额
            worksheet.getCell("G14").value = {formula:"C14-D14-F14",result:worksheet.getCell("C14")-worksheet.getCell("D14")-worksheet.getCell("F14")}
            //创客交流活动费余额
            worksheet.getCell("G15").value = {formula:"C15-D15-F15",result:worksheet.getCell("C15")-worksheet.getCell("D15")-worksheet.getCell("F15")}
            //知识产权事务费余额
            worksheet.getCell("G16").value = {formula:"C16-D16-F16",result:worksheet.getCell("C16")-worksheet.getCell("D16")-worksheet.getCell("F16")}
            //其他支出余额
            worksheet.getCell("G17").value = {formula:"C17-D17-F17",result:worksheet.getCell("C17")-worksheet.getCell("D17")-worksheet.getCell("F17")}
            //总预算
            worksheet.getCell("C12").value = {formula:"SUM(C13:C17)",result:worksheet.getCell("C13")*1+worksheet.getCell("C14")*1+worksheet.getCell("C15")*1+worksheet.getCell("C16")*1+worksheet.getCell("C17")*1}
            //已支付
            worksheet.getCell("D12").value = {formula:"SUM(D13:D17)",result:worksheet.getCell("D13")*1+worksheet.getCell("D14")*1+worksheet.getCell("D15")*1+worksheet.getCell("D16")*1+worksheet.getCell("D17")*1}
            //本次申请
            worksheet.getCell("E12").value = {formula:"SUM(E13:E17)",result:worksheet.getCell("E13")*1+worksheet.getCell("E14")*1+worksheet.getCell("E15")*1+worksheet.getCell("E16")*1+worksheet.getCell("E17")*1}
            //实际使用
            worksheet.getCell("F12").value = {formula:"SUM(F13:F17)",result:worksheet.getCell("F13")*1+worksheet.getCell("F14")*1+worksheet.getCell("F15")*1+worksheet.getCell("F16")*1+worksheet.getCell("F17")*1}
            //余额
            worksheet.getCell("G12").value = {formula:"C12-D12-F12",result:worksheet.getCell("C12")*1-worksheet.getCell("D12")*1-worksheet.getCell("F12")*1}
        //经费支出
            //总预算
            worksheet.getCell("C5").value = {formula:"SUM(C6+C12)",result:worksheet.getCell("C6")*1+worksheet.getCell("C12")*1}
            //总支出
            worksheet.getCell("D5").value=  {formula:"SUM(D6+D12)",result:worksheet.getCell("D6")*1+worksheet.getCell("D12")*1}
            //总申请
            worksheet.getCell("E5").value = {formula:"SUM(E6+E12)",result:worksheet.getCell("E6")*1+worksheet.getCell("E12")*1}
            //总实际使用
            worksheet.getCell("F5").value = {formula:"SUM(F6+F12)",result:worksheet.getCell("F6")*1+worksheet.getCell("F12")*1}
            //总余额
            worksheet.getCell("G5").value = {formula:"SUM(G6+G12)",result:worksheet.getCell("G6")*1+worksheet.getCell("G12")*1}
    
    
                // 将工作簿保存为Excel文件
                return workbook.xlsx.writeBuffer();
            })
            .then(buffer => {
                // 将Excel文件保存到本地计算机
                const excelBlob = new Blob([buffer], { type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' });
                FileSaver.saveAs(excelBlob, '学校创客专项资金使用申请表.xlsx');
            });
        });
    } 

    export {getExcel,getExcel2}